diff -uNr shadow-4.0.3/debian/control shadow-4.0.3.hacked/debian/control
--- shadow-4.0.3/debian/control	2002-10-27 20:34:16.000000000 -0500
+++ shadow-4.0.3.hacked/debian/control	2002-10-27 17:18:48.000000000 -0500
@@ -3,7 +3,7 @@
 Priority: required
 Maintainer: Karl Ramm <kcr@debian.org>
 Standards-Version: 3.5.7.0
-Build-Depends: autoconf, automake1.5, libtool, bzip2, gettext, libpam0g-dev [!hurd-i386], texinfo, file, debhelper, debconf-utils
+Build-Depends: autoconf, automake1.5, libtool, bzip2, gettext, libpam0g-dev [!hurd-i386], texinfo, file, debhelper (>= 3.0.0), debconf-utils
 
 Package: passwd
 Architecture: any
diff -uNr shadow-4.0.3/debian/control~ shadow-4.0.3.hacked/debian/control~
diff -uNr shadow-4.0.3/debian/passwd.config shadow-4.0.3.hacked/debian/passwd.config
--- shadow-4.0.3/debian/passwd.config	2002-10-27 20:34:16.000000000 -0500
+++ shadow-4.0.3.hacked/debian/passwd.config	2002-10-27 20:31:50.000000000 -0500
@@ -208,6 +208,7 @@
 			COMPARE_PW=''
 			db_input high passwd/user-password-again \
 				&& COMPARE_PW=1 || true
+			db_input medium passwd/initial-groups || true
 		fi
 	;;
 	7)
@@ -224,6 +225,18 @@
 				STATE=5
 				continue
 			fi
+
+			db_get passwd/initial-groups
+			INITIAL_GROUPS="$RET"
+			for group in $INITIAL_GROUPS; do
+			    if ! expr "$group" : '[a-z][a-z0-9]*$' >/dev/null; then
+				db_fset passwd/initial-groups seen false
+				db_fset passwd/username-bad seen false
+				db_input critical passwd/username-bad
+				STATE=5
+				continue
+			    fi
+			done
 			
 			# Compare the two passwords, loop with message if not
 			# identical, or if empty.
@@ -255,6 +268,9 @@
 			# noninteractive mode.
 			db_get passwd/user-fullname
 			adduser --disabled-password --gecos "$RET" "$USER" >/dev/null || true
+			for group in $INITIAL_GROUPS; do
+			    adduser "$USER" "$group" >/dev/null || true
+			done
 			
 			# Clear password from the db, and set the password.
 			db_set passwd/user-password ""
diff -uNr shadow-4.0.3/debian/passwd.templates shadow-4.0.3.hacked/debian/passwd.templates
--- shadow-4.0.3/debian/passwd.templates	2002-10-27 20:34:16.000000000 -0500
+++ shadow-4.0.3.hacked/debian/passwd.templates	2002-10-27 12:59:14.000000000 -0500
@@ -43,12 +43,23 @@
  The username should start with a lower-case letter, which can be followed
  by any combination of numbers and more lower-case letters. 
 
+Template: passwd/initial-groups
+Type: string
+Default: audio video cdrom
+Description: Enter the groups you want the account to be in:
+ Enter a space-separated list of groups you want the initial user
+ account to be in.
+ .
+ The defaults include "audio", which lets the user play sound,
+ "video", which lets the user play video, and "cdrom", which allows
+ mounting CD-ROM type devices.
+
 Template: passwd/username-bad
 Type: note
-Description: Invalid username entered.
- The user name you entered is invalid. Note that usernames must start with
- a lower-case letter, which can be followed by any combination of numbers
- and more lower-case letters. 
+Description: Invalid username or group name entered.
+ The user or group name you entered is invalid. Note that usernames
+ must start with a lower-case letter, which can be followed by any
+ combination of numbers and more lower-case letters.
 
 Template: passwd/user-fullname
 Type: string
diff -uNr shadow-4.0.3/debian/rules shadow-4.0.3.hacked/debian/rules
--- shadow-4.0.3/debian/rules	2002-10-27 20:34:16.000000000 -0500
+++ shadow-4.0.3.hacked/debian/rules	2002-10-27 17:16:25.000000000 -0500
@@ -80,6 +80,7 @@
 	dh_shlibdeps
 	dh_installdeb
 	debconf-mergetemplate debian/passwd.templates* > debian/passwd/DEBIAN/templates
+	dh_installdebconf
 	dh_gencontrol
 	dh_md5sums
 	dh_builddeb -ppasswd
diff -uNr shadow-4.0.3/debian/rules~ shadow-4.0.3.hacked/debian/rules~
